/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <commondefs.h>

#include <macdialog.h>
#include <flacdialog.h>
#include <oggencdialog.h>
#include <faacdialog.h>
#include <mppencdialog.h>
#include <lamedialog.h>
#include <speexencdialog.h>
#include <wavpackdialog.h>
#include <informationdialog.h>

#include <kfiledialog.h>
#include <klocale.h>
#include <informationdialog.h>

void ProfileSettings::changeEncodingType( int encodingType )
{
	while ( outputExtensionComboBox->count() )
		outputExtensionComboBox->removeItem( 0 );
	encodingSwitchesLineEdit->setText( "" );

	switch ( encodingType )
	{
		case EncodeType::decode:
			outputExtensionComboBox->insertItem( "wav" );
			break;
		case EncodeType::lame:
			outputExtensionComboBox->insertItem( "mp3" );
			break;
		case EncodeType::mppenc:
			outputExtensionComboBox->insertItem( "mpc" );
			outputExtensionComboBox->insertItem( "mpp" );
			outputExtensionComboBox->insertItem( "mp+" );
			break;
		case EncodeType::oggenc:
			outputExtensionComboBox->insertItem( "ogg" );
			break;
		case EncodeType::faac:
			outputExtensionComboBox->insertItem( "m4a" );
			outputExtensionComboBox->insertItem( "mp4" );
			outputExtensionComboBox->insertItem( "aac" );
			break;
		case EncodeType::speexenc:
			outputExtensionComboBox->insertItem( "spx" );
			outputExtensionComboBox->insertItem( "ogg" );
			break;
		case EncodeType::mac:
			outputExtensionComboBox->insertItem( "ape" );
			outputExtensionComboBox->insertItem( "mac" );
			break;
		case EncodeType::flac:
			outputExtensionComboBox->insertItem( "flc" );
			outputExtensionComboBox->insertItem( "ogg" );
			break;
		case EncodeType::wavpack:
			outputExtensionComboBox->insertItem( "wv" );
			break;
		case EncodeType::ttaenc:
			outputExtensionComboBox->insertItem( "tta" );
			break;
	}

	if ( encodingType == EncodeType::decode )
	{
		encodingSwitchesLineEdit->setText( "" );
		encodingSwitchesLineEdit->setEnabled( false );
		outputExtensionComboBox->setEnabled( true );
	}
	else if ( encodingType == EncodeType::bypass || encodingType == EncodeType::ttaenc )
	{
		encodingSwitchesLineEdit->setText( "" );
		encodingSwitchesLineEdit->setEnabled( false );
		if ( encodingType == EncodeType::bypass )
			outputExtensionComboBox->setEnabled( false );
	}
	else
	{
		encodingSwitchesLineEdit->setEnabled( true );
		outputExtensionComboBox->setEnabled( true );
	}

	if ( outputExtensionComboBox->count() )
		outputExtensionComboBox->setCurrentItem( 0 );
}

void ProfileSettings::clickedEncodingSwitchesButton()
{
	static const QString gstreamerInfo( i18n(
	"<qt><b><u><font size=\"+1\">Description:</font></u></b><br/><br/>"
	"You're provided with a raw audio source and a file sink.<br/>"
	"All you have to do is complete the pipeline and provide the extension of the resulting file.<br/>"
	"<br/>"
	"The pipeline part should look like this:<br/>"
	"<b>filter1</b> [<i>options</i>] ! <b>filter2</b> [<i>options</i>] ! ... ! <b>filterN</b> [<i>options</i>]<br/>"
	"What to link is up to you, of course.<br/><br/>"
	"<b><u><font size=\"+1\">Examples:</font></u></b><br/>"
	"<i>-AC3 encoding at 256kbps</i>: ffenc_ac3 bitrate=256000<br/>"
	"<i>-WAV output generation</i>: wavenc<br/></qt>" ) );

	// Can't help code duplication due to qtdesigner/qmake not creating classes with virtual destructors
	switch ( encodingTypeComboBox->currentItem() )
	{
		case EncodeType::lame:
		{
			lameDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::mppenc:
		{
			mppencDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::oggenc:
		{
			oggencDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::faac:
		{
			faacDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::speexenc:
		{
			speexencDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::mac:
		{
			macDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::flac:
		{
			flacDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::wavpack:
		{
			wavpackDialog dialog;
			dialog.fromEncodingSwitches( encodingSwitchesLineEdit->text() );
			dialog.exec();
			if ( dialog.result() == QDialog::Accepted )
				encodingSwitchesLineEdit->setText( dialog.toEncodingSwitches() );
			return;
		}
		case EncodeType::ttaenc:
		{
			InformationDialog infoDialog;
			infoDialog.setCaption( i18n( "True Audio Encoding" ) );
			infoDialog.setInfo( i18n(	"<qt><b><u><font size=\"+1\">Description:</font></u></b><br/><br/>"
										"A <i>very fast</i> lossless audio encoder.</qt>" ) );
			infoDialog.resize( 300, 100 );
			infoDialog.exec();
			return;
		}
		case EncodeType::gstlaunch:
		{
			InformationDialog infoDialog;
			infoDialog.setCaption( i18n( "GStreamer Encoding" ) );
			infoDialog.setInfo( gstreamerInfo );
			infoDialog.resize( 470, 240 );
			infoDialog.exec();
			return;
		}
		case EncodeType::decode:
		{
			InformationDialog infoDialog;
			infoDialog.setCaption( i18n( "Just decode" ) );
			infoDialog.setInfo( i18n(	"<qt><b><u><font size=\"+1\">Description:</font></u></b><br/><br/>"
										"Save the decoded file as a Windows PCM wave file.</qt>" ) );
			infoDialog.resize( 300, 100 );
			infoDialog.exec();
			return;
		}
		case EncodeType::bypass:
		{
			InformationDialog infoDialog;
			infoDialog.setCaption( i18n( "Bypass" ) );
			infoDialog.setInfo( i18n( "<qt><b><u><font size=\"+1\">Description:</font></u></b><br/><br/>"
								"No encoding/decoding is performed (but tags are processed).<br/>"
								"This mode exists mainly to allow saving of ripped streams without transcoding, "
								"but can also be used to reorganize files and perform some (very basic ATM) "
								"tag cleaning.</qt>" ) );
			infoDialog.resize( 370, 170 );
			infoDialog.exec();
			return;
		}
	}
}


void ProfileSettings::showNamingSchemeInfo()
{
    static const QString namingSchemeInfo( i18n(
	"<p><b><u><font size=\"+1\">Expressions:</font></u></b><br/>"
	"<b>%{artist}</b>: track artist.<br/>"
	"<b>%{album}</b>: track album.<br/>"
	"<b>%{year}</b>: track year.<br/>"
	"<b>%{track#}</b>: track number.<br/>"
	"<b>%{track##}</b>: track number (2 digits).<br/>"
	"<b>%{title}</b>: track title.<br/>"
	"<b>%{genre}</b>: track genre.<br/>"
	"<b>%{comment}</b>: track comment.<br/>"
	"<b>%{dst_ext}</b>: output file extension (depends on the encoding type).<br/>"
	"<b>%{src_ext}</b>: input file extension.<br/>"
	"<b>%{src_name}</b>: input file name (without extension).<br/>"
	"<b>%{src_dir}</b>: input file directory.<br/>"
	"</p>"
	"<p><b><u><font size=\"+1\">Functions:</font></u></b><br/>"
	"<b>capitalize{<text>}</b>: shifts first letter to uppercase and the rest to lowercase.<br/>"
	"<b>titlecase{<text>}</b>: shifts first letter of every word to uppercase and the rest to lowercase.<br/>"
	"<b>lowercase{<text>}</b>: shifts all letters to lowercase.<br/>"
	"<b>uppercase{<text>}</b>: shifts all letters to uppercase.<br/>"
	"</p>"
	"<p><b><u><font size=\"+1\">Notes:</font></u></b><br/>"
	"- DO NOT use \"{\" or \"}\" characters for other than the above. If needed, use \"\\{\" or \"\\}\" instead.<br/>"
	"- Values are the ones read by TagLib or defaults when none available (default values and tag cases are defined in Tags page).<br/>"
	"- Functions override defined tags cases. <br/>"
	"</p>"
	"<p><b><u><font size=\"+1\">Example:</font></u></b><br/>"
	"<b>Artist</b>: mark lanegan / <b>Album</b>: Field songs / <b>Title</b>: reSurrection song / <b>Track</b>: 7 / <b>Ext</b>: OGG<br/>"
	"<b>Scheme</b>: titlecase{%{artist} - %{album}/%{track##} - %{title}}.lowercase{%{dst_ext}}<br/>"
	"<b>Output file</b>: Mark Lanegan - Field Songs/07 - Resurrection Song.ogg<br/>"
	"</p>" ) );

    InformationDialog* infoDialog = new InformationDialog( this );
	infoDialog->setCaption( i18n( "Naming Scheme Info" ) );
	infoDialog->setInfo( namingSchemeInfo );
	infoDialog->show();
}



