/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include <commondefs.h>
#include <kstandarddirs.h>
#include <kfiledialog.h>

QLineEdit* ProgramSettings::getLineEdit( int program )
{
	switch ( program )
	{
		case Program::lame:			return lameLineEdit;
		case Program::mppenc:		return mppencLineEdit;
		case Program::mppdec:		return mppdecLineEdit;
		case Program::oggenc:		return oggencLineEdit;
		case Program::oggdec:		return oggdecLineEdit;
		case Program::faac:			return faacLineEdit;
		case Program::faad:			return faadLineEdit;
		case Program::speexenc:		return speexencLineEdit;
		case Program::speexdec:		return speexdecLineEdit;
		case Program::mac:			return macLineEdit;
		case Program::flac:			return flacLineEdit;
		case Program::wavpack:		return wavpackLineEdit;
		case Program::wvunpack:		return wvunpackLineEdit;
		case Program::ttaenc:		return ttaencLineEdit;
		case Program::mplayer:		return mplayerLineEdit;
		case Program::gstlaunch:	return gstlaunchLineEdit;
		case Program::streamripper:	return streamripperLineEdit;
		default:					return 0;
	}
}

void ProgramSettings::findProgram( int program )
{
	QLineEdit* programLineEdit = getLineEdit( program );
	if ( programLineEdit == 0 )
		return;

	QString programPath = KFileDialog::getOpenFileName(
							programLineEdit->text(),													// start path
							"",																			// filter
							0,																			// parent
							"Find the path to " + Program::toQString( (Program::TProgram)program ) );	// caption

	if ( programPath != QString::null )
		programLineEdit->setText( programPath );
}

void ProgramSettings::guessProgramPath( int program )
{
	QLineEdit* programLineEdit = getLineEdit( program );
	if ( programLineEdit == 0 )
		return;

	QString programPath = KStandardDirs::findExe( Program::toQString( (Program::TProgram)program ) );
	if ( programPath != QString::null )
		programLineEdit->setText( programPath );
}

void ProgramSettings::guessLamePath()
{
	guessProgramPath( Program::lame );
}

void ProgramSettings::findLame()
{
	findProgram( Program::lame );
}

void ProgramSettings::guessMppencPath()
{
	guessProgramPath( Program::mppenc );
}

void ProgramSettings::findMppenc()
{
	findProgram( Program::mppenc );
}

void ProgramSettings::guessMppdecPath()
{
	guessProgramPath( Program::mppdec );
}

void ProgramSettings::findMppdec()
{
	findProgram( Program::mppdec );
}

void ProgramSettings::guessOggencPath()
{
	guessProgramPath( Program::oggenc );
}

void ProgramSettings::findOggenc()
{
	findProgram( Program::oggenc );
}

void ProgramSettings::guessOggdecPath()
{
	guessProgramPath( Program::oggdec );
}

void ProgramSettings::findOggdec()
{
	findProgram( Program::oggdec );
}

void ProgramSettings::guessFaacPath()
{
	guessProgramPath( Program::faac );
}

void ProgramSettings::findFaac()
{
	findProgram( Program::faac );
}

void ProgramSettings::guessFaadPath()
{
	guessProgramPath( Program::faad );
}

void ProgramSettings::findFaad()
{
	findProgram( Program::faad );
}

void ProgramSettings::guessSpeexencPath()
{
	guessProgramPath( Program::speexenc );
}

void ProgramSettings::findSpeexenc()
{
	findProgram( Program::speexenc );
}

void ProgramSettings::guessSpeexdecPath()
{
	guessProgramPath( Program::speexdec );
}

void ProgramSettings::findSpeexdec()
{
	findProgram( Program::speexdec );
}

void ProgramSettings::guessFlacPath()
{
	guessProgramPath( Program::flac );
}

void ProgramSettings::findFlac()
{
	findProgram( Program::flac );
}

void ProgramSettings::guessMacPath()
{
	guessProgramPath( Program::mac );
}

void ProgramSettings::findMac()
{
	findProgram( Program::mac );
}

void ProgramSettings::guessMPlayerPath()
{
	guessProgramPath( Program::mplayer );
}

void ProgramSettings::findMPlayer()
{
	findProgram( Program::mplayer );
}

void ProgramSettings::guessGstLaunchPath()
{
	guessProgramPath( Program::gstlaunch );
}

void ProgramSettings::findGstLaunch()
{
	findProgram( Program::gstlaunch );
}

void ProgramSettings::guessStreamripperPath()
{
	guessProgramPath( Program::streamripper );
}

void ProgramSettings::findStreamripper()
{
	findProgram( Program::streamripper );
}

void ProgramSettings::guessWavpackPath()
{
	guessProgramPath( Program::wavpack );
}

void ProgramSettings::findWavpack()
{
	findProgram( Program::wavpack );
}

void ProgramSettings::guessWvunpackPath()
{
	guessProgramPath( Program::wvunpack );
}

void ProgramSettings::findWvunpack()
{
	findProgram( Program::wvunpack );
}


void ProgramSettings::guessTtaencPath()
{
	guessProgramPath( Program::ttaenc );
}

void ProgramSettings::findTtaenc()
{
	findProgram( Program::ttaenc );
}

