#ifndef _TRANSKODESCRIPT_H_
#define _TRANSKODESCRIPT_H_

/***************************************************************************
 *   Copyright (C) 2005 by Sergio Pistone                                  *
 *   sergio_pistone@yahoo.com.ar                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <commondefs.h>
#include <transkodelogger.h>

#include <transkodefileworker.h>
#include <transkodefilejob.h>
#include <transkodedialog.h>
#include "stdinlistener.h"

#include <kapplication.h>

class TransKodeScript: public KApplication
{
	Q_OBJECT

	public:

		TransKodeScript();
		virtual ~TransKodeScript();

		bool abort() { return m_configError; };

	public slots:
		void addJobs( QString message );

	protected slots:
		void slotPreferences();
		void slotConfig();

		/*void displayStreamRipStarted( int workerID, int jobID, const QString& URL );
		void displayStreamRipFinished( int workerID, int jobID, const QString& URL, const QStringList& rippedFiles );*/

		void displayJobStarted( int jobID, const QString& srcPath, const QString& dstPath, int jobType );
		void displayJobError( int jobID, const QString& srcPath, const QString& errorMsg );

		void displayRoundStats(
			int workerID,
			int transErrorCount, int transOKCount,
			int copyErrorCount, int copyOKCount,
			int jobsCancelled, int pfErrorCount );

		void amarokSuccess( int jobID, const QString& src, const QString& dst );
		void amarokError( int jobID, const QString& src );
		void amarokDone();

		void displayPopup( const QString& text, int msec=10000 );

		void deleteJob( int jobID );

	protected:
		typedef enum { add, remove } TAction;

		static void cleanUp( int ); // SIGTERM handler
		void setupMenuEntries( TAction action );

	protected:
		bool m_configError;
		StdinListener m_listener;
		TransKodeLogger m_logger;
		TransKodeConfig m_config;
		TransKodeDialog m_configDialog;
		TransKodeFileWorker m_fileWorkerThread;
		TransKodeFileWorker m_amarokWorkerThread;
		QPtrList<TransKodeFileJob> m_jobs;
};

#endif
